moBGAs = {};
source(MultiOverlayV3.modDir.."scripte/module/bgas/moBGAsConfig.lua");

function moBGAs:update(dt)
	if moModule.active.bgas.isRunning then
		if moBGAs.values.updateTimer > 0 then
			if MultiOverlayV3.timers["updateBGAs"] ~= nil then return;end;
			moSetGetExtras:addTimer( {delay=moBGAs.values.updateTimer, name="updateBGAs", repeatable=1, ms=false, action=moBGAs.load} ); 
		else
			moBGAs:load();
		end;
	end;
end;

function moBGAs:load()
	moBGAs:loadBGAs();	
end;

function moBGAs:loadBGAs()
	local playerFarmId = g_currentMission.player.farmId;	
	moBGAs.values.bgas = {}; --new 
	if moModule.bgas ~= nil and #moModule.bgas > 0 then
		local deleteObject = {};
		for index=1, #moModule.bgas do			
			if moModule.bgas[index] ~= nil then
				local isObject = moModule:isObject(moModule.bgas[index].object);
				if isObject then
					local bga = moModule.bgas[index].object;
					if bga.ownerFarmId == 0 or bga.ownerFarmId == playerFarmId then
						local bgaName = moModule.bgas[index].xmlName;
						if moBGAs.values.bgas[bgaName] == nil then moBGAs.values.bgas[bgaName] = {};end;
						moBGAs.values.bgas[bgaName][#moBGAs.values.bgas[bgaName]+1] = {general={},output={},input={},bunkerSilos={}};
						---
						local lineTableGeneral = moBGAs.values.bgas[bgaName][#moBGAs.values.bgas[bgaName]].general;
						lineTableGeneral[#lineTableGeneral+1] = {};
						local isLineTableGeneral = lineTableGeneral[#lineTableGeneral];						
						isLineTableGeneral.object = bga;
						isLineTableGeneral.objectName = moModule.bgas[index].name;
						isLineTableGeneral.xmlName = bgaName;													
						--isLineTableGeneral.productivity = 0; 
						--isLineTableGeneral.productivityName = moLanguageXml:getTxt("productivity", nil, g_i18n:getText("statistic_productivity"));
						--isLineTableGeneral.productivityColor = 1;
						---
						local lineTableOutput = moBGAs.values.bgas[bgaName][#moBGAs.values.bgas[bgaName]].output;
						if bga.bga.bunker.slots ~= nil and #bga.bga.bunker.slots > 0 and bga.bga.bunker.slots[2] ~= nil then
							lineTableOutput[#lineTableOutput+1] = {};						
							isLineTableOutput = lineTableOutput[#lineTableOutput];
							local capacity, fillLevel, fillTypesTotal = moBGAs:getFillTypeLevels(bga.bga.bunker.slots[2]);
							local fillType = moFillTypes.values.fillTypes[fillTypesTotal[1]];
							if fillType ~= nil then
								isLineTableOutput.fillTypeName = fillType.name;
							else
								isLineTableOutput.fillTypeName = moLanguageXml:getTxt("unknown", nil, "Unknown");
							end;							
							isLineTableOutput.fillTypesTotal = fillTypesTotal;
							isLineTableOutput.fillLevel = g_i18n:formatNumber(Utils.getNoNil(fillLevel, 0));
							isLineTableOutput.capacity = g_i18n:formatNumber(Utils.getNoNil(capacity, 0));
							isLineTableOutput.percentageCapacity = math.floor(100 * (fillLevel/capacity));
						end;
						---
						local lineTableInput = moBGAs.values.bgas[bgaName][#moBGAs.values.bgas[bgaName]].input;	
						if bga.bga.bunker.slots ~= nil and #bga.bga.bunker.slots > 0 and bga.bga.bunker.slots[1] ~= nil then	
							lineTableInput[#lineTableInput+1] = {};						
							isLineTableInput = lineTableInput[#lineTableInput];
							local capacity, fillLevel, fillTypesTotal = moBGAs:getFillTypeLevels(bga.bga.bunker.slots[1]);							
							isLineTableInput.fillTypeName = moLanguageXml:getTxt("catcher", nil, "Catcher");
							isLineTableInput.fillTypesTotal = fillTypesTotal;
							isLineTableInput.fillLevel = g_i18n:formatNumber(Utils.getNoNil(fillLevel, 0));
							isLineTableInput.capacity = g_i18n:formatNumber(Utils.getNoNil(capacity, 0));
							isLineTableInput.percentageCapacity = math.floor(100 * (fillLevel/capacity));
						end;	
						---	
						if bga.bunkerSilos ~= nil and #bga.bunkerSilos > 0 then
							for bunkerIndex=1, #bga.bunkerSilos do			
								if bga.bunkerSilos[bunkerIndex] ~= nil then							
									isObject = moModule:isObject(bga.bunkerSilos[bunkerIndex]);
									if isObject then
										moBGAs.values.bgas[bgaName][#moBGAs.values.bgas[bgaName]].bunkerSilos[#moBGAs.values.bgas[bgaName][#moBGAs.values.bgas[bgaName]].bunkerSilos+1] = {general={},output={},input={}};
										lineTableGeneral = moBGAs.values.bgas[bgaName][#moBGAs.values.bgas[bgaName]].bunkerSilos[#moBGAs.values.bgas[bgaName][#moBGAs.values.bgas[bgaName]].bunkerSilos].general;
										lineTableGeneral[#lineTableGeneral+1] = {};
										isLineTableGeneral = lineTableGeneral[#lineTableGeneral];
										isLineTableGeneral.object = bga.bunkerSilos[bunkerIndex];
										isLineTableGeneral.objectName = moLanguageXml:getTxt("bga", nil, "BGA").. " ".. moLanguageXml:getTxt("bunkersilo", nil, "BunkerSilo").. " ".. tostring(bunkerIndex);
										isLineTableGeneral.compactedFillLevel = g_i18n:formatNumber(bga.bunkerSilos[bunkerIndex].compactedFillLevel);
										isLineTableGeneral.compactedPercent = bga.bunkerSilos[bunkerIndex].compactedPercent;										
										isLineTableGeneral.fermentingPercent = "-";
										isLineTableGeneral.fermentingColor = nil;
										if bga.bunkerSilos[bunkerIndex].state == BunkerSilo.STATE_CLOSED then --and bga.bunkerSilos[bunkerIndex].state ~= BunkerSilo.STATE_FERMENTED then
											isLineTableGeneral.fermentingPercent = Utils.getNoNil(bga.bunkerSilos[bunkerIndex].fermentingPercent, 0);
											isLineTableGeneral.fermentingColor = MultiOverlayV3:get_hl("getProzentColor", {Utils.getNoNil(bga.bunkerSilos[bunkerIndex].fermentingPercent, 0), true}, "getProzentColor BGA Fermenting Bunkersilo ".. tostring(bunkerIndex))
										end;
										if bga.bunkerSilos[bunkerIndex].state == BunkerSilo.STATE_FERMENTED then
											isLineTableGeneral.compactedFillLevel = "-";
										end;
										--state = BunkerSilo.STATE_CLOSED, BunkerSilo.STATE_FERMENTED, BunkerSilo.STATE_DRAIN
										---
										lineTableOutput = moBGAs.values.bgas[bgaName][#moBGAs.values.bgas[bgaName]].bunkerSilos[#moBGAs.values.bgas[bgaName][#moBGAs.values.bgas[bgaName]].bunkerSilos].output;
										lineTableOutput[#lineTableOutput+1] = {};						
										isLineTableOutput = lineTableOutput[#lineTableOutput];
										local capacity, fillLevel, fillTypesTotal = 0, bga.bunkerSilos[bunkerIndex].fillLevel, {};
										local fillType = moFillTypes.values.fillTypes[bga.bunkerSilos[bunkerIndex].outputFillType];
										if fillType ~= nil then
											isLineTableOutput.fillTypeName = fillType.name;
										else
											isLineTableOutput.fillTypeName = moLanguageXml:getTxt("unknown", nil, "Unknown");
										end;										
										isLineTableOutput.fillLevel = g_i18n:formatNumber(Utils.getNoNil(fillLevel, 0));
										if Utils.getNoNil(fillLevel, 0) <= 0 then
											isLineTableOutput.fillTypeName = "Out (".. moLanguageXml:getTxt("unknown", nil, "Unknown").. ")";
										end;
										if bga.bunkerSilos[bunkerIndex].state ~= BunkerSilo.STATE_DRAIN then	
											isLineTableOutput.fillLevel = "-";
										end;										 
										isLineTableOutput.capacity = g_i18n:formatNumber(Utils.getNoNil(capacity, 0));
										isLineTableOutput.percentageCapacity = math.floor(100 * (fillLevel/capacity));
										---
										lineTableInput = moBGAs.values.bgas[bgaName][#moBGAs.values.bgas[bgaName]].bunkerSilos[#moBGAs.values.bgas[bgaName][#moBGAs.values.bgas[bgaName]].bunkerSilos].input;
										lineTableInput[#lineTableInput+1] = {};						
										isLineTableInput = lineTableInput[#lineTableInput];
										fillTypesTotal = moBGAs:getAcceptedFillTypes(bga.bunkerSilos[bunkerIndex].acceptedFillTypes);
										local fillTypes = moFillTypes.values.fillTypes[fillTypesTotal[1]];
										if fillTypes ~= nil then
											isLineTableInput.fillTypeName = fillTypes.name;
										else
											isLineTableInput.fillTypeName = moLanguageXml:getTxt("bunkerfilllevel", nil, "FillLevel");
										end;										
										isLineTableInput.fillTypesTotal = fillTypesTotal;
										isLineTableInput.fillLevel = g_i18n:formatNumber(Utils.getNoNil(fillLevel, 0));
										if bga.bunkerSilos[bunkerIndex].state == BunkerSilo.STATE_DRAIN then
											isLineTableInput.fillLevel = "-"
										end;
										isLineTableInput.capacity = g_i18n:formatNumber(Utils.getNoNil(capacity, 0));
										isLineTableInput.percentageCapacity = math.floor(100 * (fillLevel/capacity));
										---
									end;
								end;
							end;
						end;
						---
					end;				
				else
					table.insert(deleteObject, index);
				end;
			end;
		end;
		if #deleteObject > 0 then
			for _, index in pairs (deleteObject) do				
				table.remove(moModule.bgas, index);
			end;
			moModule:slotOutputCmd(true);
		end;
	end;
end;

function moBGAs:getAcceptedFillTypes(fillTypeModule)
	local fillTypesTotal = {};
	for index, isAccepted in pairs(fillTypeModule) do
		if isAccepted then
			table.insert(fillTypesTotal, index);
		end;
	end;
	return fillTypesTotal;
end;

function moBGAs:getFillTypeLevels(fillTypeModule)
	local fillLevelTotal = Utils.getNoNil(fillTypeModule.fillLevel, 0);
	local fillTypesTotal = {};
	local capacityTotal = Utils.getNoNil(fillTypeModule.capacity, 0);
	if fillTypeModule.fillTypes ~= nil and type(fillTypeModule.fillTypes) == "table" then
		for index, fillType in pairs(fillTypeModule.fillTypes) do
			--fillLevelTotal = fillLevelTotal+fillType.fillLevel;
			--capacityTotal = capacityTotal+fillType.capacity;
			table.insert(fillTypesTotal, index);
		end;
	end;
	return capacityTotal, fillLevelTotal, fillTypesTotal;
end;
