feedmixers = {};

--needs feedmixers
--lineType 2/feedmixers
function feedmixers:load(feedmixerName)
	local lineTable = {lineTyp=2, txtScroll={leftRight=true,upDown=true}};
	if moFeedMixers.values.feedmixers ~= nil and moFeedMixers.values.feedmixers[feedmixerName] ~= nil then
		for feedmixer=1, #moFeedMixers.values.feedmixers[feedmixerName] do
			if moFeedMixers.values.feedmixers[feedmixerName][feedmixer] ~= nil then
				local feedmixerGeneral = moFeedMixers.values.feedmixers[feedmixerName][feedmixer].general[1];
				lineTable[#lineTable+1] = {};
				local isLineTable = lineTable[#lineTable];
				
				isLineTable.lineClickHelp = true;
				isLineTable.lineClickHelpCallback = feedmixers.returnLineHelpIconClick
				isLineTable.helpTxt = "Click FeedMixerTyp/FeedMixerName/%/FillLevel or .... ++ for more info (or MapHotSpot)";
				
				local color = 1;				
				isLineTable.ownValues = {feedmixerName};
				isLineTable.txt = {};			
				isLineTable.txt[1] = {};			
				isLineTable.txt[1].nodeId = feedmixerGeneral.object.nodeId;
				--isLineTable.txt[1].width = 80;	--width prozent	
				isLineTable.txt[1].color = moColors:getColor(moModule.values.txtTitleColor);
				isLineTable.txt[1].bold = true;			
				local isNearObject = moModule:nearPlayerPosition(feedmixerGeneral.object, 20);				
				if isNearObject ~= nil then	isLineTable.txt[1].clickCallback = feedmixers.returnClickObjectName;end;				
				if isNearObject ~= nil and isNearObject then
					isLineTable.txt[1].txt = ">>".. feedmixerGeneral.objectName.. "<<";
				else
					isLineTable.txt[1].txt = feedmixerGeneral.objectName;
				end;
				isLineTable.txt[1].txtPos = 1;
				--productivity
				lineTable[#lineTable+1] = {};
				isLineTable = lineTable[#lineTable];				
				isLineTable.ownValues = {feedmixerName};
				isLineTable.txt = {};			
				isLineTable.txt[1] = {};			
				isLineTable.txt[1].width = 80;	--width prozent	
				color = Utils.getNoNil(moColors.prozent[feedmixerGeneral.productivityColor], 1);
				isLineTable.txt[1].color = moColors:getColor(color, nil, moModule.values.txtColor);
				isLineTable.txt[1].bold = moModule.values.txtBold;
				isLineTable.txt[1].txt = feedmixerGeneral.productivityName;
				isLineTable.txt[2] = {};			
				isLineTable.txt[2].width = 20;	--width prozent	
				isLineTable.txt[2].color = moColors:getColor(color, nil, moModule.values.txtColor);
				isLineTable.txt[2].bold = moModule.values.txtBold;
				isLineTable.txt[2].txt = feedmixerGeneral.productivity.. "%";
				--productivity
				--output
				local feedmixerOutput = moFeedMixers.values.feedmixers[feedmixerName][feedmixer].output;
				if feedmixerOutput ~= nil and #feedmixerOutput > 0 then
					for output=1, #moFeedMixers.values.feedmixers[feedmixerName][feedmixer].output do
						local outputTable = moFeedMixers.values.feedmixers[feedmixerName][feedmixer].output[output];
						lineTable[#lineTable+1] = {};
						isLineTable = lineTable[#lineTable];				
						isLineTable.ownValues = {feedmixerName};
						isLineTable.txt = {};			
						isLineTable.txt[1] = {};			
						isLineTable.txt[1].width = 80;	--width prozent
						isLineTable.txt[1].color = moColors:getColor(moModule.values.txtColor)
						isLineTable.txt[1].bold = moModule.values.txtBold;
						isLineTable.txt[1].txt = outputTable.fillTypeName;
						isLineTable.txt[2] = {};			
						isLineTable.txt[2].width = 20;	--width prozent
						isLineTable.txt[2].color = moColors:getColor(moModule.values.txtColor)
						isLineTable.txt[2].bold = moModule.values.txtBold;						
						isLineTable.txt[2].txt = outputTable.fillLevel;
						isLineTable.txt[2].clickCallback = feedmixers.returnClickFillLevelCapacityTotal;
						isLineTable.txt[2].ownValues = {tostring(outputTable.capacity), tostring(outputTable.percentageCapacity), true};
						if outputTable.palFull ~= nil then							
							lineTable[#lineTable+1] = {};
							isLineTable = lineTable[#lineTable];				
							isLineTable.ownValues = {feedmixerName};
							isLineTable.txt = {};			
							isLineTable.txt[1] = {};			
							isLineTable.txt[1].width = 80;	--width prozent
							isLineTable.txt[1].color = moColors:getColor(moModule.values.txtColor)
							isLineTable.txt[1].bold = moModule.values.txtBold;
							isLineTable.txt[1].txt = moLanguageXml:getTxt("pallets", nil, g_i18n:getText("category_pallets"));
							isLineTable.txt[2] = {};			
							isLineTable.txt[2].width = 20;	--width prozent
							isLineTable.txt[2].color = moColors:getColor(moModule.values.txtColor)
							isLineTable.txt[2].bold = moModule.values.txtBold;
							isLineTable.txt[2].txt = tostring(outputTable.palFull);
						end;
					end;
				end;
				--output
				--input
				local feedmixerInput = moFeedMixers.values.feedmixers[feedmixerName][feedmixer].input;
				if feedmixerInput ~= nil and #feedmixerInput > 0 then
					if #feedmixerInput > 0 then
						lineTable[#lineTable+1] = {};
						isLineTable = lineTable[#lineTable];					
						isLineTable.txt = {};			
						isLineTable.txt[1] = {};
						isLineTable.txt[1].color = moColors:getColor(moModule.values.txtTitleColor)
						isLineTable.txt[1].bold = moModule.values.txtBold;
						isLineTable.txt[1].txt = "----";					
						isLineTable.txt[2] = {};			
						isLineTable.txt[2].color = moColors:getColor(moModule.values.txtTitleColor)
						isLineTable.txt[2].bold = moModule.values.txtBold;
						isLineTable.txt[2].txt = "----";
					end;
					for input=1, #feedmixerInput do
						local inputTable = feedmixerInput[input];
						lineTable[#lineTable+1] = {};
						isLineTable = lineTable[#lineTable];				
						isLineTable.ownValues = {feedmixerName};
						isLineTable.txt = {};						
						isLineTable.txt[1] = {};			
						isLineTable.txt[1].width = 80;	--width prozent
						isLineTable.txt[1].color = moColors:getColor(moModule.values.txtColor)
						isLineTable.txt[1].bold = moModule.values.txtBold;
						if inputTable.fillTypesTotal ~= nil and #inputTable.fillTypesTotal > 1 then
							isLineTable.txt[1].txt = inputTable.fillTypeName.. " ++";
							isLineTable.txt[1].fillTypesTotal = inputTable.fillTypesTotal;
							isLineTable.txt[1].clickCallback = feedmixers.returnClickFillTypesTotal;							
						else
							isLineTable.txt[1].txt = inputTable.fillTypeName;
						end;
						isLineTable.txt[2] = {};			
						isLineTable.txt[2].width = 20;	--width prozent
						isLineTable.txt[2].color = moColors:getColor(moModule.values.txtColor)
						isLineTable.txt[2].bold = moModule.values.txtBold;
						isLineTable.txt[2].txt = tostring(inputTable.percentageCapacity).. "%";
						--isLineTable.txt[2].txt = tostring(inputTable.capacity) --tostring(inputTable.percentageCapacity).. "%";
						isLineTable.txt[2].clickCallback = feedmixers.returnClickFillLevelCapacityTotal;
						isLineTable.txt[2].ownValues = {tostring(inputTable.capacity), tostring(inputTable.fillLevel)};						
						--isLineTable.txt[2].txt = inputTable.fillLevel;
					end;
				end;
				--input
			end;
		end;
	end;
	feedmixers[feedmixerName] = {output=lineTable};
end;

function feedmixers.returnClickFillLevelCapacityTotal(...)
	if ... ~= nil then
		local args = ...;		
		if args.line ~= nil and args.ownValues ~= nil and args.ownValues[1] ~= nil then			
			local capacity = feedmixers[args.ownValues[1]].output[args.line].txt[2].ownValues[1];
			local fillLevel = feedmixers[args.ownValues[1]].output[args.line].txt[2].ownValues[2];
			local flipFillLevel = feedmixers[args.ownValues[1]].output[args.line].txt[2].ownValues[3];
			--if string.len(capacity) > 0 then				
				moSetGetOverlays.infoHelpBox.info.lsTimer = -1;
				local capacityLanguage = moLanguageXml:getTxt("capacity", nil, "Capacity:");
				local fillcontainerLanguage = moLanguageXml:getTxt("fillcontainer", nil, "Foodtrough:");
				local prozent = ""
				if flipFillLevel ~= nil then prozent = "%";end;				
				moSetGetOverlays.infoHelpBox.info.txt = tostring(capacityLanguage).. " ".. tostring(capacity).. "\n".. tostring(fillcontainerLanguage).. " ".. tostring(fillLevel).. tostring(prozent);				
			--end;
		end;
	end;
end;

function feedmixers.returnClickFillTypesTotal(...)
	if ... ~= nil then
		local args = ...;
		if args.line ~= nil and args.position ~= nil and args.ownValues ~= nil and args.ownValues[1] ~= nil then
			local fillTypesTotal = feedmixers[args.ownValues[1]].output[args.line].txt[1].fillTypesTotal;
			local fillTypeNamen = "";			
			for _, fillType in pairs (fillTypesTotal) do				
				local fillTypes = moFillTypes.values.fillTypes[fillType];
				if fillTypes ~= nil then
					fillTypeNamen = fillTypeNamen.. tostring(fillTypes.name).. " - ";
				end;										
			end;
			if string.len(fillTypeNamen) > 0 then
				moSetGetOverlays.infoHelpBox.info.lsTimer = -1;
				moSetGetOverlays.infoHelpBox.info.txt = tostring(fillTypeNamen);	
			end;
		end;
	end;
end;


function feedmixers.returnLineHelpIconClick(...)	
	if ... ~= nil then		
		local args = ...;		
		if args.line ~= nil and args.ownValues ~= nil and args.ownValues[1] ~= nil then
			moSetGetOverlays.infoHelpBox.help.lsTimer = -1;
			moSetGetOverlays.infoHelpBox.help.txt = tostring(feedmixers[args.ownValues[1]].output[args.line].helpTxt);
		end;
	end;
end;

function feedmixers.returnClickObjectName(...)
	if ... ~= nil then		
		local args = ...;
		if args.line ~= nil and args.ownValues ~= nil and args.ownValues[1] ~= nil then
			local feedmixerName = args.ownValues[1];
			if feedmixers[feedmixerName] ~= nil and feedmixers[feedmixerName].output ~= nil and feedmixers[feedmixerName].output[args.line] ~= nil then
				local nodeId = feedmixers[feedmixerName].output[args.line].txt[1].nodeId;
				local x, _, z = getWorldTranslation(nodeId);
				moSetGetOverlays:mapHotSpot(nil, x, z);
			end;
		end;		
	end;
end;

function feedmixers.giveOutputTable(...)	
	if ... ~= nil then
		local args = ...;
		moModule.active.feedmixers.isRunning = true;moModule.active.feedmixers.last = moModule.time.min+moModule.time.delay;
		if args.ownValues ~= nil and args.ownValues[1] ~= nil then
			local feedmixerName = args.ownValues[1];
			feedmixers:load(feedmixerName);
			return feedmixers[feedmixerName].output;
		end;		
	end;
end;

function feedmixers.reset(whichSLOT)
	if whichSLOT ~= nil and moSetGetOverlays.slot[whichSLOT] ~= nil then moSetGetOverlays.slot[whichSLOT].save = false;end;
	--feedmixers:load();	
end;

function feedmixers:generateCmd(feedmixerName)
	local _, errorTable = 0, {};
	function insertCmd(feedmixerName)
		local newCmdTable = { insert=true, cmdOldTable=MultiOverlayV3.moduleCmdTable, cmdTable = {} };	
		local feedmixerNameTemp = tostring(feedmixerName):lower();
		local languageName = moLanguageXml:getTxt(feedmixerNameTemp, nil, feedmixerName);
		newCmdTable.cmdTable[1] = {
			cmdName = "feedmixers_".. tostring(feedmixerName);
			displayName = moLanguageXml:getTxt("feedmixers", nil, "FeedMixers").. " ".. tostring(languageName);		
			multiple = true;
			sortBy = "FeedMixers";
			infoTxt = "Zeigt alle FeedMixers oder diese Category an (".. tostring(languageName).. ")";
			helpTxt = "View FeedMixers or Category";
			click = {mouseButtonLeft=true, mouseButtonMiddle=true, mouseButtonRight=true, key=true};
			lineTyp = 2;
			typ = "output";
			action = feedmixers.giveOutputTable; --a function
			ownValues = {feedmixerName}; 
		};	
		_, errorTable = moSetGetCmd:generateNewCmd(newCmdTable);
		local errorPrint = false;
		if errorPrint and #errorTable > 0 then
			for a=1, #errorTable do
				print("! ERROR ! MultiOverlayV3 Hud -->cmd generate feedmixers Cmd error ".. tostring(a).. ": ".. tostring(errorTable[a]))
			end;
		end;
	end;
	if feedmixerName ~= nil then 
		local isAlreadyExits = moSetGetCmd:cmdFromReady(nil, "feedmixers_".. feedmixerName, "multioverlayV3Module", tostring(MultiOverlayV3.metadata.title), true, MultiOverlayV3.moduleCmdTable);
		if isAlreadyExits == nil then insertCmd(feedmixerName);end;
	else
		if moModule.feedMixers ~= nil and #moModule.feedMixers > 0 then
			for index=1, #moModule.feedMixers do
				local feedmixerName = moModule.feedMixers[index].xmlName;
				local isAlreadyExits = moSetGetCmd:cmdFromReady(nil, "feedmixers_".. feedmixerName, "multioverlayV3Module", tostring(MultiOverlayV3.metadata.title), true, MultiOverlayV3.moduleCmdTable);
				if isAlreadyExits == nil then insertCmd(feedmixerName);end;
			end;			
		end;
	end;	
end;
